#include c:\exrate\uorth\gss\urbic.prc;
/* f test procs */
@=============================================================@
/* ge nov 93 revision of jun93 proc to do F test on system
     x(t) =  x(t-1) + e(1t)
     y(t) =  x(t-1) + e(2t)
   and do tests on  , 
   This version allows for e(1t) serially correlated
*/

proc(1) = ftstl(yt,xt,rr,r,maxp);
local nobs, xa1, yd, xd, xxi, gamhat, alphat,
      e1hat, e2hat, p, junk, n, dx, z, xtp,
      ip, zzi, zy, b, om, vb, bet, rbr, dn, xb,
      fst, delt, sd, o11, o22, o21, al, g, b1, phi,
      oms, ft2;

/* run OLS regressions */
nobs=rows(xt)-1;
xa1=ones(nobs,1)~xt[1:nobs,1];
yd=yt[2:nobs+1,1];
xd=xt[2:nobs+1,1];
xxi=invpd(xa1'xa1);
gamhat=xxi*(xa1'yd);
xb=xa1[.,2]-meanc(xa1[.,2]);

if maxp==0;
  alphat=xxi*(xa1'xd);
  e1hat=xd-xa1*alphat;
  e2hat=yd-xa1*gamhat;
  b1=1;
else;
  @ select lag length by BIC and estimate e1hat from autoregression @
  {p,junk}=urbic(xt,1,maxp);
  n=rows(xt);
    dx = 0|(xt[2:n,1]-xt[1:(n-1),1]);
  z=ones(n-p-1,1)~xt[(1+p):(n-1),1]; xtp=xt[(2+p):n,1];
    ip=0; do until ip>=p;
    z=z~dx[(1+p-ip):(n-1-ip),1];
    ip=ip+1; endo;
  zzi=invpd(z'z); zy=z'xtp;
  b=zzi*zy;
  e1hat=xtp-z*b;
  alphat=b[1:2,1];
  b1=1-sumc(b[3:rows(b),.]);
  e2hat=yd-xa1*gamhat;
  e2hat=e2hat[(1+p):n-1,1];
endif;


om=(e1hat~e2hat);om=(om'om)/(rows(e1hat)-1);
vb=inv(om).*.((xb'xb)/(nobs*nobs));
phi=zeros(2,1);
phi[2,1]=nobs*(gamhat[2,1]);
phi[1,1]=nobs*(alphat[2,1]-1)-r[1,1]*b1;
fst=(phi'(vb)*phi)/2;

retp(fst);
endp;

/* the null that ==1  */
rr=(0~1~0~(0))|(0~0~0~1);
r=1|1;

/* load critical values */
@load path=c:\ces\gss\fmt\ cesf;@

proc(1) = ftstcv(cesf,c0);
local e1, e2, ee, ffcv;

e1=(cesf[.,1].>c0+0.1);
e2=(cesf[.,1].<c0-0.1);
ee=ones(rows(e1),1)-e1-e2;
ffcv=selif(cesf,ee);  c0~ffcv[1,1];
retp(ffcv[.,22]~ffcv[.,33]~ffcv[.,41]);
endp;


@
format /RDN 10,3;
{j1} = ftst(alhat,0|(cig[1,1]),omega,rr,r,x[1:rows(x)-1,1]);
j1;
 @
/*
format /RDN 15,3;
@ debug @
  rndseed 8844;
  aa=zeros(100,5);ee=aa[.,1];
  i=1; do until i>100;
  if round(i/1000)==i/1000;i;endif;
  {y,x}=mcg(1,0,1,501,20);
@ {y,x}=mcgc(0,0,0,0,0,100,20);@
@  {tauh,junk}=adf(x,1,0);
  ccm=unitci(tauh,0.0,cvdf_a); ccm=ccm[1,1];
  {dhat1,om} = deltahat(x,y,ccm,1,500,0,1); @
  om=eye(2);om[2,1]=0; om[2,2]=2;
 @ om[1,2]=om[2,1];om[2,1]/sqrt(om[2,2]*om[1,1]);@
  ass=adfc(x,1,0);
  ass[2,1]=1+ass[2,1];@ass[2,1];@
  {tg,bet} = tgamm(y[2:500,.],x[1:499,.],(0|1));@bet[2,1];@
  rr=(0~1~0~0)|(0~0~0~1);r=(1|1);
  @rr=(0~0~0~1);r=1;@
  {aa[i,1]}=ftst(ass,bet,om,rr,r,x[1:rows(x)-1,1]);
  sx=(x[1:rows(x)-1,1]'x[1:rows(x)-1,1]);
  {cig} = finv(8.063,om,ass[2,1]-1,sx);
  cig=bet[2,1]*ones(2,1)-cig;cig=sortc(cig,1);
  if 1<cig[1,1]; aa[i,2]=1; endif;
  if 1>cig[2,1]; aa[i,3]=1; endif;
  if bet[2,1]<cig[1,1]; aa[i,4]=1; endif;
  if bet[2,1]>cig[2,1]; aa[i,5]=1; endif;
  ee[i,1]=(abs(sumc(cig))<10);
  @(cig')~bet[2,1];@
  i=i+1; endo;
  /*
  {a1,a2}=pctile(aa);
  output file=cvfo.out reset;
  "percentiles for F0";
  a2;
  output off;
    */
  " ";
  meanc(aa[.,1].>8.063);
  aa1=aa[.,2]+aa[.,3];
  aa1=selif(aa1,ee);
  meanc(aa1);
  aa2=aa[.,4]+aa[.,5];
  aa2=selif(aa2,ee);
  meanc(aa2);
  */


@=============================================================@

/* ge jun93 proc to invert a bivariate F statistic to get upper and lower
   confidence intervals on the second parameter (gamma) for the CES project

*/

proc(1) = finv(fcv,om,ahat,sx);
local xt, delt, sdd, o11, o22, o21, n1, d,
      n2a, n2b, n2c, n22, gam1, gam2, gam;
xt=ones(rows(xt),1)~xt;
sx=inv(xt'xt);
sx=sx[2,2];

delt=om[2,1]/sqrt(om[1,1]*om[2,2]);
sdd=1/(1-delt*delt);
o11=sdd/(om[1,1]);
o22=sdd/(om[2,2]);
o21=(-1*delt*sdd)/sqrt(om[1,1]*om[2,2]);

n1=-1*ahat*o21;
d=o22;
n2a=n1*n1;
n2b=o11*o22*ahat*ahat;
n2c=o22*fcv/sx;
n22=n2a+n2c-n2b;
@n22~(fcv)~((ahat*ahat*sx)/o11);@
if n22>0;

 gam1=(n1-sqrt(n22))/d;
 gam2=(n1+sqrt(n22))/d;
 gam=gam1|gam2;
 @gam=sortc(gam,1);@
 @(gam')~sqrt(n22);     @
else;
 gam=999*ones(2,1);
endif;


retp(gam);
endp;


/*
fcv=7.97;
sx=x[2:rows(x),1]'x[2:rows(x),1];
ahat=ass[2,1]-1;
{aa} = finv(fcv,om,ahat,sx);
aa;
*/
@=============================================================@

/* ge jun93 proc to invert a bivariate F statistic to get upper and lower
   confidence intervals on the second parameter (gamma) for the CES project

*/

proc(1) = finv2(fcv,om,xt);
local sx, delt, d0, shf, sc, gamm1, gamm2,
      gamm3, gamm4, gg;

xt=ones(rows(xt),1)~xt;
sx=inv(xt'xt);
sx=sx[2,2];

delt=om[2,1]/sqrt(om[1,1]*om[2,2]);
d0=sqrt(fcv*om[2,2]*sx);@"d0";;fcv~om[2,2]~sx~d0;@
shf=(delt*delt);
sc=(2*delt*delt-1);

gamm1=d0;
gamm2=sc*d0;
gamm3=-1*gamm2;
gamm4=-1*gamm1;

gg=gamm1|gamm2|gamm3|gamm4;
gg=sortc(gg,1);


@retp(gamm1|gamm2);@
retp(gg[1,1]|gg[4,1]);


endp;


/*
fcv=7.97;
sx=x[2:rows(x),1]'x[2:rows(x),1];
om=eye(2);om[2,1]=0.5;
{aa} = finv2(fcv,om,sx);
aa;
*/
@=============================================================@
