/* GE Dec94 program to do teh Sheffe test in the CES paper

Input :
          a2       : size of the F test
          aa1      : cesf matrix
          maxp     : max # lags in first stage

e.g.  proc(1) = sheff(yt,xt,a2,aa1);                       */


proc(1) = sheff(yt,xt,h0,a2,aa1,maxp);

local rr, p1, p2, pct, coll, cesf, ic, r,
      f, frej;

 rr=(0~1~0~0)|(0~0~0~1);

/* choose critical values */
@select column for correct size@
p1=seqa(0.005,0.005,20)|seqa(0.11,0.01,30);
p2=seqa(0.60,0.01,30)|seqa(0.90,0.005,20);
pct=p1|0.5|p2;
coll=indnv(round(100*(1-a2))/100,round(100*pct)/100)+1;

   cesf=aa1[.,1]~(aa1[.,coll]/2);

/* search over c and see if rejects */
f=zeros(rows(cesf),1);
ic=1; do until ic>rows(cesf);

r=(cesf[ic,1])|h0;
{f[ic,1]}=ftstl(yt,xt,rr,r,maxp);
      @  f[ic,1]~cesf[ic,2];@
ic=ic+1; endo;
frej=(f.<cesf[.,2]);
frej=(sumc(frej)).>0;


retp(1-frej);
endp;

      /*
@ debug @
#include mcg2.prc;
#include ftstl.prc;
#include alp2.prc;
tt1=hsec;
load path=fmt cesf;
  bet0n=0;bet0=0;
  delta=0.5;
  a2s=fstage2(delta);
  thet=0;nobss=100|1000;
  rout=zeros(rows(nobss),1);
  j=1; do until j>rows(nobss);
  c=0;
  maxp=4;
  nobs=nobss[j,1];nstart=10;alp=1+c/nobs;
  rndseed 31194;
  freg=zeros(600,1);
  imc=1; do until imc>rows(freg);
  @----- Generate data ----@
    {y,x,z}=mcg1(alp,delta,bet0,thet,nobs+1,nstart);
  {freg[imc,1]}=sheff(y,x,bet0n,a2s,cesf,maxp);
  imc=imc+1; endo;
  rout[j,1]=meanc(freg);
  j=j+1; endo;
  rout;
tt2=hsec;ttd=tt2-tt1;etstr(ttd);
*/
