#include ces.prc;
/* SUPB.PRC GE Nov 94 proc to estimate the sup bound critical values using
   the results in Table 2 of CES
   this version uses size adjusted optimal cv's based on delta

*/


proc(1)=supbo(dhat,sb,a2,s0,asel);

/*     dhat   :   Delta estimate
       sb     :   sup bound matrix of critical values (ordered by delta)
       a2     :   size of test
       s0     :   normal distribution percentiles
       asel   :   optimal sizes by delta
*/
local ddh, rsel, cl, cu, cvs, p1, p2, pct,
      coll, colu, cvv;

/* Select by interpolation critical values at dhat */

ddh=abs(dhat);
if ddh<0.99;
 rsel=round(10*ddh)/10;
 rsel=indnv(rsel,round(10*sb[.,1])/10);
 cl=sb[rsel-1,.];cu=sb[rsel,.];
        if ddh<0.1;
        cl=sb[1,.];cu=sb[2,.];
        endif;
else;
cl=sb[rows(sb)-1,.];cu=sb[rows(sb),.];
endif;

cvs=lint(ddh,cl|cu,cl[1,1]|cu[1,1]);


/* choose correct size */
if a2==0.05; asel=asel[.,1:2];           @ supports only 5 and 10 % tests @
 else; asel=asel[.,1]~asel[.,3];
endif;
@ find optimal size for size adjust @
if ddh<=0.9;
rsel=ceil(10*ddh)/10;
rsel=indnv(rsel,round(100*asel[.,1])/100);
a2=asel[rsel,2];
elseif ddh<=0.95;
rsel=0.95;
rsel=indnv(rsel,round(100*asel[.,1])/100);
a2=asel[rsel,2];
else;
rsel=0.99;
rsel=indnv(rsel,round(100*asel[.,1])/100);
a2=asel[rsel,2];
endif;


@ find column number for correct size @
p1=seqa(0.005,0.005,20);
p2=seqa(0.90,0.005,20);
pct=p1|0.5|p2;
pct=round(1000*pct)/1000;
coll=indnv(a2/2,pct)+1;
colu=indnv(round(1000*(1-(a2/2)))/1000,pct)+1;
cvv=cvs[.,coll]|s0[1,colu];
retp(sortc(cvv*(dhat/ddh),1));
endp;

/*
#include ces.prc;
#include supb.prc;
load path=fmt spdb;
load path=fmt ces3_50;
load path=fmt ces3_0;
load path=fmt asel;
dd1=supbo(0.5,spdb,0.1,ces3_0,asel)';dd1;
dd2=supb(0.5,spdb,0.17,ces3_0)';dd2;
  */
