

/*   GE may93 mod of jun92 proc to use BIC to estimate lag
     length for a ADF test
*/

proc(2) = urbic(y,fdet,maxp);

/*  Inputs     :      y      - the data
                      fdet   - flag for deterministics
                      maxp   - maximum lag length
    Outputs    :      pstar  - BIC lag choice
                      lrsel  - Likelihood ratio choice
*/

local  n, bic, s2, x, maxl, sp, nlags, p, dy,
       z, yp, dyp, ip, zzi, zy, b, u, s, s2l,
       lr, lrsel, ii, pstar;

n=rows(y); bic=zeros(maxp,1); s2=zeros(maxp,1);
if fdet == 1; x=ones(n,1); elseif fdet == 2; x=ones(n,1)~seqa(1,1,n);
   else; x=zeros(n,1); endif;
maxl=fix(maxp*((n/100)^.33));
sp=1; do until sp>(maxp);
nlags=fix(sp*((n/100)^.33));p=nlags;
dy = 0|(y[2:n,1]-y[1:(n-1),1]);
z=y[(1+maxl):(n-1),1]; yp=y[(2+maxl):n,1]; dyp=dy[(2+maxl):n,1];
if sumc(sumc(x)).ne.0; z=z~x[(2+maxl):n,.]; endif;
ip=0; do until ip>=p;
  z=z~dy[(1+maxl-ip):(n-1-ip),1];
ip=ip+1; endo;
zzi=invpd(z'z); zy=z'yp;
b=zzi*zy;
u=yp-z*b; s=(u'u)/(rows(u)-cols(z));
s2[sp,1]=s;
bic[sp,1]=ln(s)+p*(ln(rows(u))/rows(u)); /*#### BIC VERSION #### */
sp=sp+1; endo;

z=y[(1+maxl):(n-1),1]; yp=y[(2+maxl):n,1]; dyp=dy[(2+maxl):n,1];
if sumc(sumc(x)).ne.0; z=z~x[(2+maxl):n,.]; endif;
zzi=invpd(z'z); zy=z'yp;
b=zzi*zy;
u=yp-z*b; s=(u'u);@/(rows(u)-cols(z));@
s2l=s|s2[1:maxp-1,1];
lr=rows(u)*((s2l-s2)./s2);
lrsel=0;
ii=maxp; do until ii<1;
if lr[ii,1]>2.71;
   lrsel=ii; ii=-1;
endif;
ii=ii-1;endo;


@if lrsel == 0; lrsel = 1; endif;@
pstar=minindc(bic);@  if pstar <3; pstar=3; endif;@
retp(pstar,lrsel);
endp;

/*
@ debug @
@rndseed 7192;@
fdet=1; nmc=100;
a1=zeros(nmc,4); a2=zeros(nmc,4);
i=1; do until i>nmc;
eps=rndn(201,1); eps=eps[2:201,1]+0.7*eps[1:200,1];
@eps1=recserar(eps,0,0.9);@
y=recserar(eps,0,1);
{a4,a1[i,.],a3,a2[i,.]}=dfs(y,fdet);
i=i+1; endo;
@meanc(a1.<-2.86);@
@meanc(a2);@
  */
