/*  GE May 93 various procs to do CES project */

@----------------------------------------------------@;
proc(2) = tgamm(y,x,fdt,h0);

local nobs, xa, xxi, xy1, beta, e, s2, tstat;
   nobs=rows(x);
   if fdt == 1;
   xa=x[1:nobs,1]~ones(nobs,1);
   elseif fdt == 0;
   xa=x[1:nobs,1];
   else;
   xa=x[1:nobs,1]~ones(nobs,1)~seqa(1,1,nobs);
   endif;
   xxi=invpd(xa'xa);
   xy1=xa'y;
   beta=xxi*xy1;    @ OLS Estimate @
   e=y-xa*beta;
   s2=(e'e)/(rows(e)-cols(xa));
   tstat=(beta[1,1]-h0[2,1])/sqrt(s2*xxi[1,1]);
retp(tstat,beta);
endp;

@tgamm(y[2:rows(y),1],x[1:rows(y)-1,.],h0);@

@----------------------------------------------------@;

@----------------------------------------------------@;
proc(2) = tgamgls(y,x,h0);

local nobs, ya, xa, xxi, xy1, beta, xb, xxb,
      xyb, betab, e, s2, tstat;
   nobs=rows(x);
   ya=y-y[1,1];
   xa=x-x[1,1];
   xxi=invpd(xa'xa);
   xy1=xa'ya;
   beta=xxi*xy1;    @ OLS Estimate @
   xb=ones(rows(x),1)~x;
   xxb=invpd(xb'xb);
   xyb=xb'y;
   betab=xxb*xyb;    @ OLS Estimate @
   e=y-xb*betab;
   s2=(e'e)/(rows(e)-cols(xa));
   tstat=(beta-h0)/sqrt(s2*xxi);

retp(tstat,beta);
endp;
@tgamm(y[2:rows(y),1],x[1:rows(y)-1,.],h0);@

@----------------------------------------------------@;








/* GE 21 may 93 proc to select lamd for matrix selection */

proc(1)=sellam(lambda);
local lamd, aa, i;

lambda=(lambda)*100;
lamd=99999;
aa=seqa(0,1,100);
i=1; do until i>rows(aa);
if lambda>(aa[i,1]-1); lamd=aa[i,1]; endif;
i=i+1; endo;

if lamd==99999; "Can't find lamda matrix"; endif;

retp(lamd);
endp;

@sellam(0.15);@


@----------------------------------------------------@;
/* GE proc to do linear interp on a vector of values */

proc(1) = lint(x,yv,xv);
local xl, xu, ye, i, yl, yu;

/*   inputs :
        x    = 1x1 value between known points
        yv   = 2xk matrix (lower over upper) of value to be est at known points
        xv   = 2x1 vector (lower then upper) of value at known points
     output
        y    = y value corresponding to the x input
*/

    xl=xv[1,1];     xu=xv[2,1];
    ye=zeros(1,cols(yv));
    i=1; do until i>cols(yv);
    yl=yv[1,i];     yu=yv[2,i];
    ye[1,i]=yu - (yu-yl)*((xu-x)/(xu-xl));
    i=i+1; endo;
    retp(ye);
    endp;

/*
 /* debug */
x=0.5;
xv=0|1;
yv=zeros(1,5)|(seqa(1,1,5)');
lint(x,yv,xv);
*/

@----------------------------------------------------@;
/*  rewrite of ADF.prc to get ests of constant and
    unit root coefficient */

@ ADFc                    JHS 4/20/90
 computes Dickey-Fuller test statistics
  y = data series, x = deterministic terms (matrix), p = no. of lags of diffs
@
proc(1)= adfc(y,fdet,p);
local n, x, nlags, dy, z, yp, ip, zzi, zy,
      b, u, s, ao, a1, nrhohat, what, t;
n=rows(y);
if fdet == 1; x=ones(n,1); elseif fdet == 2; x=ones(n,1)~seqa(1,1,n);
   else; x=zeros(n,1); endif;

if p<0; nlags=fix(4*((n/100)^.33)); endif;
dy = 0|(y[2:n,1]-y[1:(n-1),1]);
z=y[(1+p):(n-1),1]; yp=y[(2+p):n,1]-y[(1+p):(n-1),1];
if sumc(sumc(x)).ne.0; z=z~x[(2+p):n,.]; endif;
ip=0; do until ip>=p;
  z=z~dy[(1+p-ip):(n-1-ip),1];
ip=ip+1; endo;
zzi=invpd(z'z); zy=z'yp;
b=zzi*zy;
u=yp-z*b; s=(u'u)/(rows(u)-cols(z));
if sumc(sumc(x)).ne.0; ao=sumc(b[1:1+cols(x),1]); else; ao=b[1,1]; endif;
a1=sumc(b)-ao;
nrhohat=rows(u)*(b[1,1])/(1-a1);
what=s/((1-a1)*(1-a1));
t=(b[1,1])/sqrt(s*zzi[1,1]);
@yp[1:10,.]~z[1:10,.];@
@retp(nrhohat|t,what);@
retp(b[2,1]|b[1,1]);
endp;

@{as}=adfc(x,1,0);@

@----------------------------------------------------@;
/*  rewrite of ADF.prc to get tests of local to unity
    root coefficients and t stat */

@ ADFc                    JHS 4/20/90
 computes Dickey-Fuller test statistics
  y = data series, x = deterministic terms (matrix), p = no. of lags of diffs
@
proc(1)= adfl(y,fdet,p,alp0);
local n, x, nlags, dy, z, yp, ip, zzi, zy,
      b, u, s, ao, a1, nrhohat, what, t;
n=rows(y);
if fdet == 1; x=ones(n,1); elseif fdet == 2; x=ones(n,1)~seqa(1,1,n);
   else; x=zeros(n,1); endif;

if p<0; nlags=fix(4*((n/100)^.33)); endif;
dy = 0|(y[2:n,1]-y[1:(n-1),1]);
z=y[(1+p):(n-1),1]; yp=y[(2+p):n,1]-y[(1+p):(n-1),1];
if sumc(sumc(x)).ne.0; z=z~x[(2+p):n,.]; endif;
ip=0; do until ip>=p;
  z=z~dy[(1+p-ip):(n-1-ip),1];
ip=ip+1; endo;
zzi=invpd(z'z); zy=z'yp;
b=zzi*zy;
u=yp-z*b; s=(u'u)/(rows(u)-cols(z));
if sumc(sumc(x)).ne.0; ao=sumc(b[1:1+cols(x),1]); else; ao=b[1,1]; endif;
a1=sumc(b)-ao;
nrhohat=rows(u)*(b[1,1])/(1-a1);
what=s/((1-a1)*(1-a1));
t=(b[1,1]-alp0+1)/sqrt(s*zzi[1,1]);
retp(t);
endp;

@{as}=adfc(x,1,0);@

