/* SUPB.PRC GE Nov 94 proc to estimate the sup bound critical values using
   the results in Table 2 of CES
*/


proc(1)=supb(dhat,sb,a2,s0);

/*     dhat   :   Delta estimate
       sb     :   sup bound matrix of critical values (ordered by delta)
       a2     :   size of test
*/

local rsel, ddh, i, cu, cl, cvs, p1, p2, pct, coll,
      colu, cvv;


/* Select by interpolation critical values at dhat */

ddh=abs(dhat);
if ddh<0.99;
 rsel=round(100*ddh)/100;
 rsel=indnv(rsel,round(100*sb[.,1])/100);
 cl=sb[rsel-1,.];cu=sb[rsel,.];
        if ddh<0.1;
        cl=sb[1,.];cu=sb[2,.];
        endif;
else;
cl=sb[rows(sb)-1,.];cu=sb[rows(sb),.];
endif;

cvs=lint(ddh,cl|cu,cl[1,1]|cu[1,1]);


/* choose correct size */
@ find column number for correct size @
p1=seqa(0.005,0.005,20);
p2=seqa(0.90,0.005,20);
pct=p1|0.5|p2;
pct=round(1000*pct)/1000;
coll=indnv(a2/2,pct)+1;
colu=indnv(round(1000*(1-(a2/2)))/1000,pct)+1;
cvv=cvs[.,coll]|s0[1,colu];
retp(sortc(cvv*(dhat/ddh),1));
endp;

/*
#include ces.prc;
load path=fmt spdb;
load path=fmt ces3_50;
load path=fmt ces3_0;
dd1=supb(0.5,spdb,0.17,ces3_0)';dd1;
minc(ces3_50[.,11])~maxc(ces3_50[.,33]);
minindc(ces3_99[.,11]);
  */
